<?php 
// VERSION 1.3 du 28 fvrier 2004
//
// TELECHARGEMENT DERNIERE VERSION :
//      voir http://www.gouillou.com/spip
//
// DESCRIPTION ;
//      Liste tous les articles d'une base SPIP avec leurs statuts et permet de modifier ces derniers 
//      Diffrents tris (N, Date, etc.) et Filtres par statut
//
// CREDITS :
//      Remerciements  henri.gabolde@laposte.net pour son sript m_statut.php (du 16-11-03) a servi de base  celui-ci et pour ses commentaires et tests
//      Voir : http://www.uzine.net/spip_contrib/article.php3?id_article=292
//
// LICENCE GPL
//      Merci de me faire parvenir toute amlioration de ce script
//
// INSTALLATION :
//      Test sur Spip 1.4.2 et Spip 1.7 sur base MySQL 3.23.49-max-nt avec PHP 4.2
//      Placer les deux fichiers apg_statut.php et apg_statut_2.php (ou apg_statut.php3 et apg_statut_2.php3 selon votre serveur) dans le rpertoire /ecrire de SPIP
//      Eventuellement (non obligatoire) rajouter les images apg_flechebas.gif et apg_flechehaut.gif dans le rpertoire ecrire/img_pack
//
// UTILISATION :
//      Appeler le fichier /ecrire/apg_statut.php (ou apg_statut.php3 selon votre serveur)
//      Cliquer sur les titres de colonnes (sauf 'Auteur') provoque un tri sur cette colonne, avec inversion (ascendant/descendant)  chaque clic
//      Diffrents filtres sont possibles
//      Utiliser le combo Statut pour modifier les statuts
//      Valider ou Annuler par les boutons en bas du tableau
//      ATTENTION : Pas de procdure de confirmation !!!!
//
// LIEN DIRECT DANS LES FAVORIS : 
//      Bookmarklet tel que dcrit par Thierry  http://www.uzine.net/spip_contrib/article.php3?id_article=291
//      Si PHP3 : javascript:var%20url=location.href.substring(0,%20location.href.lastIndexOf('/'));var%20expression=/(ecrire)/;var%20ecrire='';%20if%20(expression.test(url)==false)%20{%20ecrire='/ecrire';};location=url%20+%20ecrire%20+%20'/apg_statut.php3';
//      Si PHP : javascript:var%20url=location.href.substring(0,%20location.href.lastIndexOf('/'));var%20expression=/(ecrire)/;var%20ecrire='';%20if%20(expression.test(url)==false)%20{%20ecrire='/ecrire';};location=url%20+%20ecrire%20+%20'/apg_statut.php';

// SANS GARANTIE D'AUCUNE SORTE !!
// philippe@gouillou.com 27-01-04

// ----------------------------------------------------------------------------------------------



// DETECTION DE L'EXTENSION (.php3 OU .php)

    $ext = "php"; 
    if (substr($_SERVER['PHP_SELF'],-1) == 3)  $ext = "php3"; 
    include ("inc.$ext"); 

// RECUPERATION DES DONNEES (POUR SI REGISTER_GLOBALS = OFF)

    $TRI                = $_GET[TRI];
    $ORDRE              = $_GET[ORDRE];
    $FIL_1              = $_GET[FIL_1];
    $FIL_2              = $_GET[FIL_2];
    if ($_GET[FILTRE])  $FILTRE = $_GET[FILTRE];

    if ($_POST[FILTRE]) $FILTRE = $_POST[FILTRE];
    $filtre_statut      = $_POST[filtre_statut];
    $liste              = $_POST[liste];
    $f_prepa            = $_POST[f_prepa];
    $f_prop             = $_POST[f_prop];
    $f_publie           = $_POST[f_publie];
    $f_poubelle         = $_POST[f_poubelle];
    $f_refuse           = $_POST[f_refuse];

    



// TRI ET FILTRE

    // VALEURS PAR DEFAUT 
    if (!$TRI)          $TRI    = "id_article"; 
    if (!$ORDRE)        $ORDRE  = "ASC";

    // INVERSION ORDRE DE TRI
    if ($ORDRE=="DESC") $ORDRE_INV="ASC";
    if ($ORDRE=="ASC")  $ORDRE_INV="DESC";

    // CONSTRUCTION FILTRE #1 : par GET
    if ($ID)    $FIL_2=$ID;
    if (!$FILTRE) {
        if (!$FIL_1) {
            $FILTRE = "" ;
            $AFFICH_FILTRE = "" ;
        }else{
            if ($FIL_1=="auteur") {   
                $bareQueryAut = "select id_article from spip_auteurs_articles where id_auteur= ".stripslashes($FIL_2);
                $resultAut = MYSQL_QUERY($bareQueryAut);
                while($rowAut = mysql_fetch_array($resultAut)){
                    $liste_art .= $rowAut["id_article"].","  ;
                }
                $liste_art = "(".substr("$liste_art",0,-1).")";
                $FILTRE = " WHERE id_article in $liste_art" ;
                $filtre_statut = "off";
            }else{
                if ($FIL_1=="date") {   
                    $FILTRE = " WHERE date >= '".substr(stripslashes($FIL_2),0,11)." 00:00:00' && date <= '".substr(stripslashes($FIL_2),0,11)."23:59:59'" ;
//echo "<H3>".$FILTRE."</H3>";
                }else{
                    $FILTRE = " WHERE ".$FIL_1." = ".stripslashes($FIL_2)." " ;
                    $AFFICH_FILTRE = "FILTRE SUR ".$FIL_1." = ".stripslashes($FIL_2) ;
                }
            }
        }
    }else{
        $FILTRE = URLDECODE($FILTRE);
        $AFFICH_FILTRE = $FILTRE;
    }
    
    // CONSTRUCTION FILTRE #2 : PAR CHECKBOX
    if ($ID)    $FIL_2=$ID;
    if ($filtre_statut == "on") {
        // Si tous ou aucun pas de filtre
        if ((($f_prepa * $f_prop * $f_publie * $f_poubelle * $f_refuse) == 1) || (($f_prepa + $f_prop + $f_publie + $f_poubelle + $f_refuse) == 0)) {
            $FILTRE = "" ;
            $AFFICH_FILTRE = "" ;
        }else{
            if ($f_prepa == 1)    $FILTRE .= "(statut = 'prepa') OR ";
            if ($f_prop == 1)    $FILTRE .= "(statut = 'prop') OR ";
            if ($f_publie == 1)   $FILTRE .= "(statut = 'publie') OR ";
            if ($f_poubelle == 1) $FILTRE .= "(statut = 'poubelle') OR ";
            if ($f_refuse == 1)   $FILTRE .= "(statut = 'refuse') OR ";
            $FILTRE = " WHERE ".substr("$FILTRE", 0, -3); 
            $AFFICH_FILTRE = "FILTRE SUR ".$FIL_1." = ".stripslashes($FIL_2) ;
        }
    }

// DEFINITION DES FONCTIONS 

    // Dtermination du nom des auteurs  partir de l'id_article :
    function auteur ($id_article,$ext) {
        $nom_auteur= "";
        $bareQuery = "select id_auteur from spip_auteurs_articles where id_article = $id_article";
        $resultall = MYSQL_QUERY($bareQuery);
        while($row = mysql_fetch_array($resultall)){
            $id_auteur = $row["id_auteur"] ;
            $bareQuery2 = "select nom from spip_auteurs where id_auteur = $id_auteur";
            $resultall2 = MYSQL_QUERY($bareQuery2);
            while($row2 = mysql_fetch_array($resultall2)){
                // Si plusieurs auteurs, ils seront spars par un " - "
                $nom_auteur .= "<A href=".$PHP_SELF."?FIL_1=auteur&FIL_2='$id_auteur'&TRI=".$TRI."&ORDRE=".$ORDRE."><IMG SRC='img_pack/apg_filtre.gif' BORDER= 0 ALT='Filtrer sur le nom auteur'></A>&nbsp;<A HREF=auteurs_edit.$ext?id_auteur=".$id_auteur." target='_blank'>".$row2["nom"]."</A> - " ;
            }
        }
        return substr("$nom_auteur", 0, -2); 
    }

// LECTURE TABLE RUBRIQUE

    //Dtermination du nom de la rubrique  partir de l'id_rubrique et mise en mmoire (pour qu'il n'y ait qu'une seule lecture de la table)
    $bareQueryRub = "select id_rubrique, titre from spip_rubriques";
    $resultRub = MYSQL_QUERY($bareQueryRub);
    while($rowRub = mysql_fetch_array($resultRub)){
        $id_rubrique = $rowRub["id_rubrique"] ;
            $titre_rubrique[$id_rubrique] = $rowRub["titre"] ;
    }
    
    
    
// DEBUT PAGE
debut_page("APG-STATUT");

// TAILLE DE LA POLICE
echo "<STYLE type='text/css'><!--
    td {  font-family: Arial, Helvetica, sans-serif; font-size: 11px}
    select { font-size: 10px }
--></STYLE>";

// TITRE

echo "<br><br><br>";
gros_titre("APG_STATUT : modifier le statut des articles");
echo "<br><br>";

/*
// SECURITE 
if ($connect_statut != "0minirezo" OR  !$connect_toutes_rubriques) {
    echo "<H3><FONT COLOR = red>Vous n'avez pas acc&egrave;s &agrave; cette page.</FONT></H3>";
    fin_page();
    exit;
}
*/
// SECURITE 
if ($connect_statut != "0minirezo") {
    echo "<H3><FONT COLOR = red>Vous n'avez pas acc&egrave;s &agrave; cette page.</FONT></H3>";
    fin_page();
    exit;
}

// RESTRICTION DES ADMINISTRATEURS RESTREINTS
if (!$connect_toutes_rubriques) {
    $bareQueryRest = "select id_rubrique from spip_auteurs_rubriques where id_auteur= $connect_id_auteur";
    $resultRest = MYSQL_QUERY($bareQueryRest);
    while($rowRest = mysql_fetch_array($resultRest)){
        $liste_rub .= $rowRest["id_rubrique"].","  ;
    }
    $liste_rub = "(".substr("$liste_rub",0,-1).")";
    $FILTRE_RUB = "id_rubrique in $liste_rub" ;
}    

//AIDE
echo "<FONT FACE='Verdana,Arial,Helvetica,sans-serif' SIZE=2>";
    echo "<P ALIGN= CENTER>Cliquer sur les titres de colonnes (sauf Auteur) modifie le classement et inverse l'ordre.";
    echo "<BR>Cliquer sur le contenu d'une cellule permet d'ouvrir dans une nouvelle fentre la page Spip Edit correspondante.";
    echo "<BR>Cliquer sur <IMG SRC='img_pack/apg_filtre.gif' BORDER= 0> dans chaque cellule permet de filtrer la liste d'articles.";
    echo "<BR>Les checkboxes ci-dessous permettent de filtrer la liste d'articles sur le statut.</P>";
    echo "<br>";

// CHECKBOXES DE FILTRE :

    // DEFINITION DES FILTRES CHECKBOX
    if ($f_prepa == 1)    $c_prepa = "checked";
    if ($f_prop == 1)     $c_prop = "checked";
    if ($f_publie == 1)   $c_publie = "checked";
    if ($f_refuse == 1)   $c_refuse = "checked";
    if ($f_poubelle == 1) $c_poubelle = "checked";

    // AFFICHAGE TABLE
    echo "<FORM name='form1' method='post' action='apg_statut.$ext'>";
        echo "<TABLE width='50%' border='0' cellspacing='2' cellpadding='2' align=center>";
            echo "<TR>";
                echo "<TD align=center bgcolor=#FFFFFF><B>R&eacute;dac.</B></TD>";
                echo "<TD bgcolor=#fff1c6 align=center><B>Eval.</B></TD>";
                echo "<TD bgcolor=#b4e8c5 align=center><B>Publi&eacute;</B></TD>";
                echo "<TD bgcolor=#ffa4a4 align=center><B>Refus&eacute;</B></TD>";
                echo "<TD bgcolor=#DDDDDD align=center><B>Poubelle</B></TD>";
            echo "</TR>";
            echo "<TR>";
                echo "<TD bgcolor=#FFFFFF align=center><INPUT type='checkbox' name='f_prepa' value='1' $c_prepa></TD>";
                echo "<TD bgcolor=#fff1c6 align=center><INPUT type='checkbox' name='f_prop' value='1' $c_prop></TD>";
                echo "<TD bgcolor=#b4e8c5 align=center><INPUT type='checkbox' name='f_publie' value='1' $c_publie></TD>";
                echo "<TD bgcolor=#ffa4a4 align=center><INPUT type='checkbox' name='f_refuse' value='1' $c_refuse></TD>";
                echo "<TD bgcolor=#DDDDDD align=center><INPUT type='checkbox' name='f_poubelle' value='1' $c_poubelle></TD>";
            echo "</TR>";
        echo "</TABLE>";
        echo "<CENTER>";  
            echo "<INPUT type=hidden name=filtre_statut value='on'>";
            echo "<INPUT type=submit name=Submit value='Filtrer'>";
            echo "<INPUT type=reset  name=Submit2 value='Reset'>";
        echo "</CENTER>";  
    echo "</FORM>";


// DEBUT FORM MODIFICATON
echo "<form action='apg_statut_2.$ext' method='post'>" ;

    // DEBUT TABLE
    echo " <table summary='aff_articles' align='center' border=0 cellpadding='3'  cellspacing='0' width=95% bgcolor='#ffffff' align='center' >";
    
        //AFFICHAGE TITRES COLONNES
        echo "<TR BGCOLOR=#BBBBBB>";    
            $champ[0]       = "id_article";
            $champ_aff[0]   = "&nbsp;ID&nbsp;";
            $champ[1]       = "id_article";
            $champ_aff[1]   = "AUTEUR";
            $champ[2]       = "titre";
            $champ_aff[2]   = "TITRE";
            $champ[3]       = "id_rubrique";
            $champ_aff[3]   = "RUBRIQUE";
            $champ[4]       = "date";
            $champ_aff[4]   = "DATE";
            $champ[5]       = "statut";
            $champ_aff[5]   = "STATUT";
            
            echo "<TD><B>&nbsp;N&nbsp;</B></TD>";
            For ($i=0 ; $i <6 ; $i++) {
                echo "<TD>";
                    if ($i != 1) {
                        echo "<A href=".$PHP_SELF."?FILTRE=".URLENCODE(stripslashes($FILTRE))."&TRI=".$champ[$i]."&ORDRE=".$ORDRE_INV." TITLE='Tri par $champ[$i] $ORDRE_INV'>&nbsp;<B>".$champ_aff[$i]."</B></A> ";
                        if ($TRI == "$champ[$i]" && $ORDRE == "DESC") echo "<IMG src=img_pack/apg_flechebas.gif width=8 height=7 border=0>&nbsp;";
                        if ($TRI == "$champ[$i]" && $ORDRE == "ASC") echo "<IMG src=img_pack/apg_flechehaut.gif width=8 height=7 border=0>&nbsp;";
                    } else {
                        echo "<B>".$champ_aff[$i]."</B>";
                    }
                echo "</TD>";
            }
        echo "</TR>";

        // REQUETE 
        
        // Prise en compte administrateurs restreints : 
        if (!$connect_toutes_rubriques) {
            if (!$FILTRE)   {
                $FILTRE = " WHERE ".$FILTRE_RUB;
            } else {
                $FILTRE .= " AND ".$FILTRE_RUB;
            }
        }
        $req_tous = "SELECT id_article, titre, id_rubrique, date, statut FROM spip_articles ".stripslashes($FILTRE)." ORDER BY $TRI $ORDRE $LIMIT";
        echo "<INPUT type=hidden name= 'requete' value='".URLENCODE("$req_tous")."'>";
        $result_tous = spip_query($req_tous);
        $compteur = 0;
        while ($row_tous = mysql_fetch_array($result_tous)){
            // Le compteur sert  viter les ventuels problmes dus  un appel direct  la page apg_statut_2
            $compteur++;            
            $ID             = $row_tous[0];
            $titre_art      = $row_tous[1];
            $rub_art        = $row_tous[2];
            $date_art       = $row_tous[3];
            $stat_art       = $row_tous[4];
            
            // RAZ
            $prepa ="" ;
            $prop ="" ;
            $publie ="" ;
            $poubelle ="" ;
            $refuse ="" ;

            // COULEUR DES LIGNES EN FONCTION DU STATUT PLUS DEFINITION SELECTED DU OPTION SELECT
            if ($stat_art=="prepa") {
                $color="#FFFFFF";
                $prepa = "selected" ;
            }
            if ($stat_art=="prop"){
                $color="#fff1c6";
                $prop = "selected" ;
            }
            if ($stat_art=="publie"){
                $color="#b4e8c5";
                $publie = "selected" ;
            }
            if ($stat_art=="poubelle"){
                $color="#DDDDDD";
                $poubelle = "selected" ;
            }
            if ($stat_art=="refuse") {
                $color="#ffa4a4";
                $refuse = "selected" ;
            }

            $statut_affich = "<select name='statut_".$row_tous[0]."'>
                <OPTION style='BACKGROUND-COLOR: white' value=prepa $prepa>en cours de rdaction
                <OPTION style='BACKGROUND-COLOR: #fff1c6' value=prop $prop>propos  l'valuation
                <OPTION style='BACKGROUND-COLOR: #b4e8c5' value=publie $publie>publi en ligne
                <OPTION style='BACKGROUND: url(img_pack/rayures-sup.gif)' value=poubelle $poubelle> la poubelle
                <OPTION style='BACKGROUND-COLOR: #ffa4a4' value=refuse $refuse>refus</OPTION>  
            </select>\n";
       
            // AFFICHAGE LIGNES
            echo "<tr bgcolor=$color>
                    <td>$compteur</td>
                    <td>$ID</td> 
                    <td>".auteur($ID,$ext)."</td> 
                    <td><A href=".$PHP_SELF."?FILTRE=".urlencode("WHERE titre='$titre_art'")."&TRI=".$TRI."&ORDRE=".$ORDRE."><IMG SRC='img_pack/apg_filtre.gif' BORDER= 0 ALT='Filtrer sur le titre article'></A>&nbsp;<A HREF='articles.$ext?id_article=$ID' target='_blank'>$titre_art</A></td> 
                    <td><A href=".$PHP_SELF."?FILTRE=".urlencode("WHERE id_rubrique='$rub_art'")."&TRI=".$TRI."&ORDRE=".$ORDRE."><IMG SRC='img_pack/apg_filtre.gif' BORDER= 0 ALT='Filtrer sur la rubrique'></A>&nbsp;<A HREF='naviguer.$ext?coll=$rub_art' target='_blank' title ='".$titre_rubrique[$rub_art]."'>&nbsp;$rub_art ".substr("$titre_rubrique[$rub_art]",0,15)."</A></td> 
                    <td><A href=".$PHP_SELF."?FIL_1=date&FIL_2=".substr($date_art,0,10)."&TRI=".$TRI."&ORDRE=".$ORDRE."><IMG SRC='img_pack/apg_filtre.gif' BORDER= 0 ALT='Filtrer sur le jour'></A>&nbsp;$date_art</td> 
                    <td><A href=".$PHP_SELF."?FILTRE=".urlencode("WHERE statut='$stat_art'")."&TRI=".$TRI."&ORDRE=".$ORDRE."><IMG SRC='img_pack/apg_filtre.gif' BORDER= 0 ALT='Filtrer sur le statut'></A>&nbsp;$statut_affich</td> 
                </tr>";
        }

    // FIN TABLE
    echo "</table> <br>";

    echo "<INPUT type=hidden name=compteur value='".$compteur."'>";
    echo "<INPUT type=hidden name=ext value='".$ext."'>";
    echo "<INPUT type=hidden name=modif value='modif'>";
    echo "<INPUT type=submit name=Submit value='Submit'>";
    echo "<INPUT type=reset  name=Submit2 value='Reset'>";

//FIN FORM
echo "</form>";

fin_page();
?>
